Page MenuHomePhabricator

Add Mobile skin Preference
Closed, DeclinedPublic

Description

Shouldn't there be two skin Preferences, one for Desktop, and one for Mobile?
And no, don't make the user be in Mobile mode to change the Mobile skin,
and Desktop mode, to change the Desktop skin. List them all in one place.

Event Timeline

Jidanni created this task.Aug 6 2017, 3:41 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptAug 6 2017, 3:41 PM
Aklapper changed the task status from Open to Stalled.Aug 6 2017, 6:40 PM

Hi, please see and follow the structure on https://mediawiki.org/wiki/How_to_report_a_bug when creating tasks by describing the underlying problem you experience for the proposed potential solution.

I am saying that back in the old days, things were simple. There was
only Desktop.

But nowadays there are two states, Mobile and Desktop.

(That's why there is $wgDefaultSkin vs. $wgMFDefaultSkinClass .
And also $wgMFAutodetectMobileView.)

Skins can detect if they are being used in Mobile vs. Desktop, and
behave differently.

Skin A might act like X when in Desktop mode, and act like Y when in
Mobile mode.

Skin B might act like Z in both Desktop and Mobile modes.

Therefore instead of one monolithic skin Preferences, there needs to be
two:

Desktop skin:
[x]...
[ ]...
[ ]...

Mobile skin:
[x]...
[ ]...
[ ]...

OK maybe this is a bug only after one has installed an extension. I'll
take a gamble and retag it.

Aklapper added a comment.EditedAug 9 2017, 9:18 AM

@Jidanni: Could you please provide an actual use case? So far it is unclear which actual existing problem this would solve. "X", "Y", "Z" and "..." are pretty vague use cases. ;)

This comment was removed by mmodell.
bmansurov added a subscriber: bmansurov.

Removing the MobileFrontend tag as it is not a skin and is not affected by the problem mentioned.

mmodell added a subscriber: mmodell.
Jidanni added a comment.EditedAug 9 2017, 8:40 PM

Think of sites unlike Wikipedia.
Wikipedia has m.en.wikipedia.org and en.wikipedia.org, two separate sites.
Now imagine a single site with all the skins of both available.

I'm hereby asking for a third and also last time for an actual, specific use case example for "Preferences".

Currently on radioscanningtw.jidanni.org users can only set a
preference to use

  1. MinervaNeue on Desktop and MinervaNeue on Mobile.

or

  1. Vector on Desktop and Vector on Mobile.

I want to give them the additional choices of setting their
preferences to

  1. MinervaNeue on Desktop and Vector on Mobile.
  1. Vector on Desktop and MinervaNeue on Mobile.

Proposing to decline this task, as this is about adding even more preferences, plus the problem to solve is that any skin should work on any device instead of forcing users to choose a skin for each device's screen size.
Plus I really don't see why anyone would want to use Vector on mobile. If you wanted to, click "Desktop" at the bottom of the mobile page - problem solved.

Jidanni added a comment.EditedAug 10 2017, 12:42 PM

Nobody would be forcing them to make two choices.

If they don't set a Moblie preference then their Desktop preference
would be used for Mobile as it is currently.

But somebody is (currently) forcing them to make one choice!

Let's say a certain editor in a certain skin doesn't work in a certain
mobile browser. Well, the user would have the choice to pick another
skin, all without having to click the bottom of the page, or change
their preferences messing up Desktop, and then have to change it back
later when on Desktop, about twice per day etc.

Then after a few months when the bug is fixed and the site updated, they
can change it back.

If a certain editor in a certain skin doesn't work in a certain mobile browser, the editor and/or skin and/or mobile browser need to get fixed instead of adding yet another preference for yet another workaround.

OK I just tried it.

Why do you force me to use Vector on Mobile?

Why do you force me to use MinervaNeue on Desktop?

Why can't I use MinervaNeue on Mobile, and Vector on Desktop, without
having to go into Preferences and switch it each time?

Sure there is the toggle at the bottom of each page, but that doesn't
toggle the skin.

Jidanni renamed this task from Shouldn't there be two skin Preferences, one for Desktop, and one for Mobile? to Add Mobile skin Preference.Aug 10 2017, 4:00 PM
Jdlrobson closed this task as Declined.Aug 11 2017, 4:39 PM
Jdlrobson added a subscriber: Jdlrobson.

There seems to be a lot of confusion here.

If they don't set a Moblie preference then their Desktop preference
would be used for Mobile as it is currently.

But somebody is (currently) forcing them to make one choice!

That's not true.
Mobile skin is defined for all users by the sysadmin when he sets $wgMFDefaultSkinClass
Desktop skin is defined for all users by the sysadmin when he sets $wgDefaultSkin

The value of $wgDefaultSkin can be overriden by a logged in user on Special:Preferences - the choice has no impact on the value of $wgMFDefaultSkinClass

If a mobile user desperately wants to change their mobile skin and is technical, they can do so using the hidden user preference mobileskin. We purposely don't add this to preferences as for the average user it's a bit overwhelming to have to understand not only the concept of skins but that they might want different skins on desktop and mobile.

But nowadays there are two states, Mobile and Desktop.

Only if you add MobileFrontend extension. If managing two sites - a desktop and mobile site - is too much of a headache, then don't do it. Simply use a responsive skin such as https://www.mediawiki.org/wiki/Skin:Timeless - that will give your users a single consistent experience that works across mobile and desktop.